import { IntegrationApiExcutorParams, ToolApi } from '../tools/types';
export declare abstract class Integration {
    abstract readonly name: string;
    abstract readonly logoUrl: string;
    abstract readonly tools: Record<string, ToolApi>;
    authType: string;
    constructor();
    protected get toolSchemas(): any;
    protected get toolDocumentations(): Record<string, {
        comment: string;
        doc?: string;
    }>;
    protected get baseClient(): any;
    getApiClient(): Promise<any>;
    protected _generateIntegrationTools<T>(): T;
    executeTool: <T extends keyof this["tools"]>(tool: T, params: Omit<IntegrationApiExcutorParams<Parameters<Awaited<ReturnType<this["getApiClient"]>>[T]>[0] extends object ? Parameters<Awaited<ReturnType<this["getApiClient"]>>[T]>[0] : {}>, "getIntegration">) => Promise<Record<string, any>>;
}
export declare class GmailIntegration extends Integration {
    readonly name = "GMAIL";
    readonly logoUrl = "";
    constructor(config: {
        apiKey: string;
    });
    readonly tools: {
        readonly gmailGetProfile: ToolApi<undefined>;
    };
}
//# sourceMappingURL=index.d.ts.map