import { Integration } from '../integration';
import { Agent } from '../agent';
import { Logger, RegisteredLogger } from '../logger';
import { SyncConfig } from '../sync/types';
import { AllTools, ToolApi } from '../tools/types';
import { MastraEngine } from '../engine';
import { MastraVector } from '../vector';
import { LLM } from '../llm';
export declare class Mastra<TIntegrations extends Integration[], MastraTools extends Record<string, ToolApi<TIntegrations, Record<string, any>, Record<string, any>>> = {}, TSyncs extends Record<string, SyncConfig<TIntegrations, MastraTools, any>> = Record<never, never>> {
    private engine?;
    private vectors?;
    private tools;
    private agents;
    llm: LLM<TIntegrations, MastraTools, keyof AllTools<TIntegrations, MastraTools>>;
    private integrations;
    private logger;
    private syncs;
    constructor(config: {
        tools?: MastraTools;
        syncs?: TSyncs;
        agents?: Agent<TIntegrations, MastraTools>[];
        integrations?: TIntegrations;
        engine?: MastraEngine;
        vectors?: Record<string, MastraVector>;
        logger?: Logger;
    });
    sync<K extends keyof TSyncs>(key: K, params: TSyncs[K] extends SyncConfig<any, any, infer P> ? P : never): Promise<void>;
    getAgent(name: string): Agent<TIntegrations, MastraTools, unknown>;
    getIntegration(name: string): Integration;
    availableIntegrations(): {
        name: string;
        integration: Integration;
    }[];
    getTools(): AllTools<TIntegrations, MastraTools>;
    setLogger({ key, logger }: {
        key: RegisteredLogger;
        logger: Logger;
    }): void;
    getLogger(key: RegisteredLogger): Logger<import("../logger").BaseLogMessage> | undefined;
}
//# sourceMappingURL=index.d.ts.map